package com.steerinfo.baseinfo.meterbasemetertypeconf.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.user.UserPayload;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasemetertypeconf.model.MeterBaseMetertypeConf;
import com.steerinfo.baseinfo.meterbasemetertypeconf.service.IMeterBaseMetertypeConfService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.*;
import java.math.BigDecimal;

/**
 * MeterBaseMetertypeConf RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-11-17 12:01
 * 类描述
 * 修订历史：
 * 日期：2021-11-17
 * 作者：generator
 * 参考：
 * 描述：MeterBaseMetertypeConf RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbasemetertypeconfs")
public class MeterBaseMetertypeConfController extends BaseRESTfulController {

    @Autowired
    IMeterBaseMetertypeConfService meterBaseMetertypeConfService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasemetertypeconf:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseMetertypeConf> list = meterBaseMetertypeConfService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasemetertypeconf:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseMetertypeConf> list = meterBaseMetertypeConfService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseMetertypeConf对象创建")
    @ApiImplicitParam(name = "meterBaseMetertypeConf", value = "详细实体meterBaseMetertypeConf", required = true, dataType = "MeterBaseMetertypeConf")
    //@RequiresPermissions("meterbasemetertypeconf:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseMetertypeConf model){
        MeterBaseMetertypeConf meterBaseMetertypeConf = meterBaseMetertypeConfService.add(model);
        return success(meterBaseMetertypeConf);
    }

    @ApiOperation(value="创建", notes="根据MeterBaseMetertypeConf对象创建")
    @ApiImplicitParam(name = "meterBaseMetertypeConf", value = "详细实体meterBaseMetertypeConf", required = true, dataType = "MeterBaseMetertypeConf")
    //@RequiresPermissions("meterbasemetertypeconf:create")
    @PostMapping(value = "/add")
    public RESTfulResult add1(@ModelAttribute MeterBaseMetertypeConf model){
        try {
            String msg = meterBaseMetertypeConfService.checkandadd(model);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasemetertypeconf:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseMetertypeConf meterBaseMetertypeConf = meterBaseMetertypeConfService.getById(id);
        return success(meterBaseMetertypeConf);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseMetertypeConf信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseMetertypeConf", value = "详细实体meterBaseMetertypeConf", required = true, dataType = "MeterBaseMetertypeConf")
    })
    //@RequiresPermissions("meterbasemetertypeconf:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseMetertypeConf model){
        UserPayload payload = UserPayload.getCurrUser();
        String userId = payload.getUserCode();
        String userName = payload.getUserName();
        model.setUpdateTime(new Date());
        model.setUpdateManName(userName);
        model.setUpdateManNo(userId);
        model.setId(id);
        MeterBaseMetertypeConf meterBaseMetertypeConf = meterBaseMetertypeConfService.modify(model);
        return success(meterBaseMetertypeConf);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasemetertypeconf:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseMetertypeConfService.delete(ids);
    	}
      return success();
    }
}
